function result = kfdapred(X, samples, labels, testsamples);

% Gaussian kernel
% D+1 parameters

[n, D] = size(samples);   % number of training cases and dimension of samples space
[nn, D] = size(testsamples);       % number of testsamples cases and dimension of samples space
expX = exp(X);              % exponentiate the hyperparameters once and for all

% first, we write out the covariance matrix Q for the training sampless ...

Z = zeros(n,n);                                         % create and zero space
for d = 1:D                                           % non-linear contribution
  Z = Z + expX(d)*(repmat(samples(:,d),1,n)-repmat(samples(:,d)',n,1)).^2;
end
Z = exp(-0.5*Z);
Z = [Z ones(length(labels),1)];
Q = Z'*Z;
Q = Q + expX(D+1)*eye(n+1)  + 1e-3*eye(n+1);
% ... then we compute the covariance between training and testsamples sampless ...
A = zeros(nn,n);                                       % create and zero space
for d = 1:D
  A = A + expX(d)*(repmat(testsamples(:,d),1,n)-repmat(samples(:,d)',nn,1)).^2;
end
A = exp(-0.5*A);
A = [A ones(size(testsamples,1),1)];
% Now, write out the desired terms
result = A*(Q\(Z'*labels));    
